#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>


void
calcc(double w0, double t, double b0, double b1, double b2, double a0, double a1, double a2)
{
	double xn, xnm1, xnm2;
	double ynm1, ynm2;

	double k = w0 / tan(w0 * t * 0.5);
	double k2 = k * k;
	double denom = a0 * k2 + a1 * k + a2;

	xn = (b0 * k2 + b1 * k + b2) / denom;

	xnm1 = (2.0 * b2 - 2.0 * b0 * k2) / denom;

	xnm2 = (b0 * k2 - b1 * k + b2) / denom;

	ynm1 = (2.0 * a2 - 2.0 * a0 * k2) / denom;

	ynm2 = (a0 * k2 - a1 * k + a2) / denom;


	printf("xn = %15.8lg, xnm1 = %15.8lg, xnm2 = %15.8lg, ynm1 = %15.8lg, ynm2 = %15.8lg\n",
		xn, xnm1, xnm2, ynm1, ynm2);
}

int
main(int argc, char *argv[])
{
	double w0, t, b0, b1, b2, a0, a1, a2;

	if (argc < 8)
	{
		fprintf(stderr,"Usage: <prog> w0 Ts b0 b1 b2 a0 a1 a2\n w0 -- opt freq, Ts Sampletime (b0*s^2 + b1*s + b2) / (a0*s^2 + a1*s + a2)\n");
		exit(1);
	}
	w0 = strtod(argv[1], NULL);
	t = strtod(argv[2], NULL);
	b0 = strtod(argv[3], NULL);
	b1 = strtod(argv[4], NULL);
	b2 = strtod(argv[5], NULL);
	a0 = strtod(argv[6], NULL);
	a1 = strtod(argv[7], NULL);
	a2 = strtod(argv[8], NULL);

	calcc(w0, t, b0, b1, b2, a0, a1, a2);

	exit(0);
	return 0;
}

