

//
//
// Copyright(C) 2017 John S Dyson
// All rights reserved.
//
// This source code is an unpublished proprietary document, and is available only
// under a written license.
// 

#include <sys/types.h>

#undef _POSIX_C_SOURCE
#define _POSIX_C_SOURCE 200112L
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
const static int MAXTMPSTR = 1024;
#if !defined(CLANG)
const char* __attribute__((externally_visible)) __attribute__((noinline))
#else
const char* 
#endif
lstrerror_r(int __attribute__((unused)) errcode, char *bufarg, int bufargsize)
{
	//
	// WE STRONGLY TRY TO AVOID USING THE STATIC BUFFER BECAUSE OF THREADING, and ALSO WE DON'T
	// WANT TO ADD ANY BLOCKING, so WE ALLOW A STOMP IF NEEDED -- INCREDIBLY SELDOM.
	//
	char *buf;
	int bufsize;
	static char errerrmsgbuf[MAXTMPSTR];
	//
	// we assume that the return code is 64bit, just in case we get a char* return for 64 bit machine.
	//

	if (bufarg != nullptr)
	{
		buf = bufarg;
		bufsize = bufargsize;
	}
	else
	{
		buf = errerrmsgbuf;
		bufsize = sizeof errerrmsgbuf;
	}
#if !defined(NOSTRERROR)
	if ( ::strerror_r(errcode, buf, (size_t) bufsize) == nullptr)
		return buf;
#else
	buf = strncpy(buf, strerror(errcode), bufsize);
	return buf;
#endif
	
	::sprintf(buf, "Error string not available: %d", errcode);
	return buf;
}
